<?php
/**
*
* @package phpBB3
* @version $Id: posts_anywhere.php 1202 2008-04-22 5:32:10Z handyman $
* @copyright (c) 2008 StarTrekGuide
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_posts_anywhere
{
	var $u_action;

	function main($id, $mode)
	{
		define('LAST_POST', 0);
		define('FIRST_POST', 1);

		global $db, $template, $user;
		$this->tpl_name = 'acp_posts_anywhere';
		$this->page_title = 'POSTS_ANYWHERE';

		$action = request_var('action', '');
		$submit = isset($_POST['submit']) ? true : false;
		$instance_id = request_var('instance_id', 0);

		switch ($action)
		{
			case 'code':
				$sql = 'SELECT instance_template
					FROM ' . POSTS_ANYWHERE_TABLE . '
					WHERE instance_id = ' . $instance_id;
				$result = $db->sql_query($sql);
				$instance_template = $db->sql_fetchfield('instance_template');
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'PHP_CODE'		=> sprintf($user->lang['PHP_CODE'], $instance_id),
					'HTML_CODE'		=> htmlspecialchars(sprintf($user->lang['HTML_CODE'], ($instance_template) ? $instance_template : 'viewtopic.html')),
				));
			break;

			case 'delete':
				$sql = 'DELETE FROM ' . POSTS_ANYWHERE_TABLE . ' WHERE instance_id = ' . $instance_id;
				$db->sql_query($sql);
				trigger_error($user->lang['INSTANCE_DELETED'] . adm_back_link($this->u_action));
			break;

			case 'edit':
				$delete = request_var('delete', 0);
				if ($delete)
				{
					$sql = 'DELETE FROM ' . POSTS_ANYWHERE_OPTIONS_TABLE . ' WHERE option_id = ' . $delete;
					$db->sql_query($sql);
				}
				else if ($submit)
				{
					$sql_ary = array(
						'instance_name'		=> utf8_normalize_nfc(request_var('instance_name', '', true)),
						'instance_desc'		=> utf8_normalize_nfc(request_var('instance_desc', '', true)),
						'instance_template'	=> request_var('instance_template', 'posts_anywhere'),
					);

					$sql = 'UPDATE ' . POSTS_ANYWHERE_TABLE . '
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE instance_id = ' . $instance_id;
					$db->sql_query($sql);

					trigger_error($user->lang['INSTANCE_UPDATED'] . adm_back_link($this->u_action . '&amp;instance_id=' . $instance_id . '&amp;action=' . $action));
				}
				else if (isset($_POST['new_option']))
				{
					$sql_ary = array(
						'instance_id'		=> $instance_id,
						'post_id'			=> request_var('post_id', 0),
						'forum_id'			=> request_var('forum_id', 0),
						'recursive'			=> request_var('recursive', false),
						'post_limit'		=> request_var('post_limit', 1),
						'single_post_topic'	=> request_var('single_post_topic', LAST_POST),
						'character_limit'	=> request_var('character_limit', 0),
					);

					$sql = 'INSERT INTO ' . POSTS_ANYWHERE_OPTIONS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$db->sql_query($sql);

					trigger_error($user->lang['OPTION_CREATED'] . adm_back_link($this->u_action . '&amp;instance_id=' . $instance_id . '&amp;action=' . $action));
				}
				else if (isset($_POST['update']))
				{
					$post_ids			= request_var('post_id', array(0));
					$forum_ids			= request_var('forum_id', array(0));
					$recursive			= request_var('recursive', array(0 => false));
					$post_limits		= request_var('post_limit', array(1));
					$single_post_topics	= request_var('single_post_topic', array(LAST_POST));
					$character_limits	= request_var('character_limit', array(0));

					foreach ($post_ids as $key => $var)
					{
						$sql_ary = array(
							'post_id'			=> $var,
							'forum_id'			=> $forum_ids[$key],
							'recursive'			=> (isset($recursive[$key]) ? $recursive[$key] : 0),
							'post_limit'		=> $post_limits[$key],
							'single_post_topic'	=> $single_post_topics[$key],
							'character_limit'	=> $character_limits[$key],
						);

						$sql = 'UPDATE ' . POSTS_ANYWHERE_OPTIONS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE option_id = ' . $key;
						$db->sql_query($sql);
					}

					trigger_error($user->lang['OPTIONS_UPDATED'] . adm_back_link($this->u_action . '&amp;instance_id=' . $instance_id . '&amp;action=' . $action));
				}

				$sql = 'SELECT *
					FROM ' . POSTS_ANYWHERE_TABLE . '
					WHERE instance_id = ' . $instance_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'INSTANCE_ID'		=> $row['instance_id'],
					'INSTANCE_NAME'		=> $row['instance_name'],
					'INSTANCE_DESC'		=> $row['instance_desc'],
					'INSTANCE_TEMPLATE'	=> $row['instance_template'],
				));

				$sql = 'SELECT *
					FROM ' . POSTS_ANYWHERE_OPTIONS_TABLE . '
					WHERE instance_id = ' . $instance_id;
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('options', array(
						'OPTION_ID'			=> $row['option_id'],
						'INSTANCE_ID'		=> $row['instance_id'],
						'POST_ID'			=> $row['post_id'],
						'FORUM_ID'			=> $row['forum_id'],
						'RECURSIVE'			=> ($row['recursive']) ? 'checked="checked"' : '',
						'POST_LIMIT'		=> $row['post_limit'],
						'SINGLE_POST_TOPIC'	=> $row['single_post_topic'],
						'CHARACTER_LIMIT'	=> $row['character_limit'],

						'U_DELETE'			=> $this->u_action . '&amp;instance_id=' . $instance_id . '&amp;action=' . $action . '&amp;delete=' . $row['option_id'],
					));
				}
				$db->sql_freeresult($result);
			break;

			default:
				switch ($mode)
				{
					default:
					case 'main':
						if ($submit)
						{
							$sql_ary = array(
								'instance_name'		=> utf8_normalize_nfc(request_var('name', '', true)),
								'instance_desc'		=> utf8_normalize_nfc(request_var('desc', '', true)),
								'instance_template'	=> request_var('template', 'posts_anywhere'),
							);
							$sql = 'INSERT INTO ' . POSTS_ANYWHERE_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
							$db->sql_query($sql);
						}

						// select posts anywhere instances
						$sql = 'SELECT *
							FROM ' . POSTS_ANYWHERE_TABLE;
						$result = $db->sql_query($sql);

						while ($row = $db->sql_fetchrow($result))
						{
							$template->assign_block_vars('instances', array(
								'INSTANCE_ID'		=> $row['instance_id'],
								'INSTANCE_NAME'		=> $row['instance_name'],
								'INSTANCE_DESC'		=> $row['instance_desc'],
								'INSTANCE_TEMPLATE'	=> $row['instance_template'],
								'U_CODE'			=> $this->u_action . '&amp;action=code&amp;instance_id=' . $row['instance_id'],
								'U_DELETE'			=> $this->u_action . '&amp;action=delete&amp;instance_id=' . $row['instance_id'],
								'U_EDIT'			=> $this->u_action . '&amp;action=edit&amp;instance_id=' . $row['instance_id'],
							));
						}
						$db->sql_freeresult($result);

					break;
				}
			break;
		}

		$template->assign_vars(array(
			'S_' . strtoupper($action)	=> true,
		));

	}
}

?>